# Mapper

Extends \DataType

Filename Mapper maps source file name(s) to target file name(s).

Built-in mappers can be accessed by specifying they "type" attribute: ``

Custom mappers can be specified by providing a dot-path to a include_path-relative class: ``

author | Hans Lellelid hans@xmpl.org
package | phing.types

### Methods

## __construct

    __construct(\Project $project)

### Arguments

#### $project

`\Project`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## Create the classpath to be used when searching for component being defined

    createClasspath()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Factory, returns inmplementation of file name mapper as new instance

    getImplementation()

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Performs the check for circular references and returns the referenced Mapper.

    getRef()

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## Set the class name of the FileNameMapper to use.

    setClassname( $classname)

throws |

### Arguments

#### $classname

``

## Set the classpath to be used when searching for component being defined

    setClasspath(\Path $classpath)

throws |

### Arguments

#### $classpath

`\Path`

An Path object containing the classpath.

## Reference to a classpath to use when loading the files.

    setClasspathRef(\Reference $r)

throws |

### Arguments

#### $r

`\Reference`

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## Set the argument to FileNameMapper.setFrom

    setFrom( $from)

throws |

### Arguments

#### $from

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Set the argument to FileNameMapper.setTo

    setTo( $to)

throws |

### Arguments

#### $to

``

## Set the type of FileNameMapper to use.

    setType( $type)

throws |

### Arguments

#### $type

``

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

### Properties

## type

    type :

### Type(s)

``

## classname

    classname :

### Type(s)

``

## from

    from :

### Type(s)

``

## to

    to :

### Type(s)

``

## classpath

    classpath :

### Type(s)

``

## classpathId

    classpathId :

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`